/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


//dep2C++ generated
#include "runtime.h"
class  SuperKernel__s_elem ;
class  DistributedArray__s_elem ;
class  Gr__s_elem ;
class GVars {
public:
int VarpC_9;
int VarpC_8;
int VarpC_7;
int VarpC_6;
int VarpC_5;
int VarpC_4;
int VarpC_3;
int VarpC_2;
int VarpC_1;
int VarpC_0;
} *GlobalVars;
const int lm = 5;
const int nm = (2) + (1 << lm);
const int lt = lm;
const int lb = 2;
const int dimsize[3] = { 4,4,1 };
extern "C" {
       double acos(double );
       double acosh(double );
       double asin(double );
       double asinh(double );
       double atan(double );
       double atan2(double , double );
       double atanh(double );
       double cbrt(double );
       double ceil(double );
       double copysign(double , double );
       double cos(double );
       double cosh(double );
       double drem(double , double );
       double erf(double );
       double erfc(double );
       double exp(double );
       double expm1(double );
       double fabs(double );
       double finite(double );
       double floor(double );
       double fmod(double , double );
       double frexp(double , int * );
       double gamma(double );
       double hypot(double , double );
       double infnan(int );
       int isinf(double );
       int isnan(double );
       double j0(double );
       double j1(double );
       double jn(int , double );
       double ldexp(double , int );
       double lgamma(double );
       double log(double );
       double log10(double );
       double log1p(double );
       double logb(double );
       double modf(double , double * );
       double pow(double , double );
       double rint(double );
       double scalb(double , int );
       double sin(double );
       double sinh(double );
       double sqrt(double );
       double tan(double );
       double tanh(double );
       double y0(double );
       double y1(double );
       double yn(int , double );
       double aint(double );
       double anint(double );
       int irint(double );
       int nint(double );
}
struct libm_exception {
       int type;
       char  *name;
       double arg1,arg2,retval;
} ;
extern "C" {
       int matherr(libm_exception * );
}
extern unsigned long  int ev_class;
typedef  char  *str;
typedef  int logical;
typedef  int integer;
typedef  int position;
const int BUFN = ((nm) + (2)) * ((nm) + (2));
typedef  double buff_t[BUFN];
enum  {
 PROJ = 1,INTERP,RESID,PSINV,NORM,COMM,TOTAL
}deb_t;
static str deb_str[8] = { "'0'","Projection","Interpolation","Residual","Pseudo-inverse","Norms","Communications"," _TOTAL_ " };
class  s_elem {
public:
public:
       s_elem  *Self(int i, int j);
public:
       s_elem  *Self(int i);
public:
       SuperKernel__s_elem  *ThisCollection;
public:
       int index2;
public:
       int index1;
public:
       int Ident;
public:
       void  DeleteTemp();
public:
       void  LocalShiftStep2();
public:
       void  LocalShiftStep1(int dim, int distance);
public:
       void  LocalBroadcastDim2(DistributedArray__s_elem *array, int step);
public:
       void  LocalReduceDim2(DistributedArray__s_elem *array, int step);
public:
       void  LocalBroadcastDim1(DistributedArray__s_elem *array, int step);
public:
       void  LocalBroadcast(DistributedArray__s_elem *array, int step);
public:
       void  LocalReduceDim1(DistributedArray__s_elem *array, int step);
public:
       void  LocalReduce(DistributedArray__s_elem *array, int step);
public:
       void  Set_ThisCollection(DistributedArray__s_elem *C);
public:
       void  LocalCopy(DistributedArray__s_elem *array);
public:
       void  BroadcastTemp(DistributedArray__s_elem &array, int step);
public:
       void  LocalGSum(DistributedArray__s_elem &array, int step);
public:
       void  ResetDotProd(DistributedArray__s_elem &arg1);
public:
       s_elem  *temporaryelement;
public:
       double dotprodtemp;
public:
       void  WhereAmI();
public:
       double Dot(s_elem arg1);
public:
       void  dev2(Gr__s_elem & );
public:
       void  dev1();
public:
       void  who_is_myproc();
public:
       void  processor_norm2u3(Gr__s_elem *array, int step);
public:
       void  LocalBroadcast(Gr__s_elem *array, int step);
public:
       void  normalize_norm();
public:
       void  ResetNorm2u3();
public:
       void  surf_from_buf(int dir, int side, int mode);
public:
       void  surf2buf(int dir, int side, int surf_mode);
public:
       void  loc_psinv(Gr__s_elem &r);
public:
       void  loc_interp(Gr__s_elem &z);
public:
       void  loc_rprj3(Gr__s_elem &r);
public:
       void  loc_resid(Gr__s_elem &u, Gr__s_elem &v);
public:
       void  init_elem();
public:
       void  coarser_elem(Gr__s_elem &finer);
private:
       int start[3],stop[3];
private:
       logical has_neighbor[2][3];
public:
       int mx[3];
public:
       int myproc;
public:
       double  *p;
public:
       buff_t sidebuf;
public:
       double rnmu_tmp,rnm2_tmp;
public:
         s_elem(){
       
          p = (double *) 0;
       }
public:
         s_elem(int _start[3], int _stop[3]){
       
          int i,j;
          for (i = 0 ; (i) < (3) ; (i)++)
          {
             start[i] = _start[i];
             stop[i] = _stop[i];
           }
          if ((((((mx[0]) + (2)) * ((mx[1]) + (2))) >  (BUFN)) || ((((mx[1]) + (2)) * ((mx[2]) + (2))) >  (BUFN))) || ((((mx[2]) + (2)) * ((mx[0]) + (2))) >  (BUFN))) 
          {
             printf("%s\n","Buffer too small");
             exit(1);
           }
           p = new double [(((mx[0]) + (2)) * ((mx[1]) + (2))) * ((mx[2]) + (2))] ;
          if ( !(p)) 
          {
             printf("%s\n","Out of memory");
             exit(1);
           }
        }
public:
       void   elem_destructor(){
       
          delete  p;
          p = (double *) 0;
       }
public:
         ~s_elem(){
       
          elem_destructor();
       }
public:
       double &  operator ()(int i1, int i2, int i3){
       
          return p[((((((((i1) -(start[0])) + (1)) * ((mx[1]) + (2))) * ((mx[2]) + (2))) + ((((i2) -(start[1])) + (1)) * ((mx[2]) + (2)))) + (i3)) -(start[2])) + (1)];
       }
public:
       double &  operator ()(int i[3]){
       
          return (*(this ))(i[0],i[1],i[2]);
       }
public:
       double &  operator ()(position i){
       
          return p[i];
       }
public:
       position  pos_ind(int i1, int i2, int i3){
       
          return ((((((((i1) -(start[0])) + (1)) * ((mx[1]) + (2))) * ((mx[2]) + (2))) + ((((i2) -(start[1])) + (1)) * ((mx[2]) + (2)))) + (i3)) -(start[2])) + (1);
       }
public:
       void  zero3();
public:
       void  resid(s_elem &u, s_elem &v);
public:
       void  rprj3(s_elem &r);
public:
       void  interp(s_elem &z);
public:
       void  psinv(s_elem &r);
public:
       double  locsum(int i1, int i2, int i3, double a[4]){
       
          typedef  double  *pdouble;
          pdouble v[3][3];
          v[0][0] = &((*(this ))((i1) -(1),(i2) -(1),(i3) -(1)));
          v[0][1] = ((v[0][0]) + (mx[2])) + (2);
          v[0][2] = ((v[0][1]) + (mx[2])) + (2);
          v[1][0] = &((*(this ))(i1,(i2) -(1),(i3) -(1)));
          v[1][1] = ((v[1][0]) + (mx[2])) + (2);
          v[1][2] = ((v[1][1]) + (mx[2])) + (2);
          v[2][0] = &((*(this ))((i1) + (1),(i2) -(1),(i3) -(1)));
          v[2][1] = ((v[2][0]) + (mx[2])) + (2);
          v[2][2] = ((v[2][1]) + (mx[2])) + (2);
          return ((((a[0]) * (v[1][1][1])) + ((a[1]) * ((((((v[0][1][1]) + (v[2][1][1])) + (v[1][0][1])) + (v[1][2][1])) + (v[1][1][0])) + (v[1][1][2])))) + ((a[2]) * ((((((((((((v[1][0][0]) + (v[1][0][2])) + (v[1][2][0])) + (v[1][2][2])) + (v[0][1][0])) + (v[0][1][2])) + (v[2][1][0])) + (v[2][1][2])) + (v[0][0][1])) + (v[0][2][1])) + (v[2][0][1])) + (v[2][2][1])))) + ((a[3]) * ((((((((v[0][0][0]) + (v[0][0][2])) + (v[0][2][0])) + (v[0][2][2])) + (v[2][0][0])) + (v[2][0][2])) + (v[2][2][0])) + (v[2][2][2])));
       }
public:
       double  locsum(position pos, double a[4]){
       
          typedef  double  *pdouble;
          pdouble v[3][3];
          v[0][1] = &((*(this ))(((pos) -(((mx[2]) + (2)) * ((mx[1]) + (2)))) -(1)));
          v[0][0] = (v[0][1]) -((mx[2]) + (2));
          v[0][2] = ((v[0][1]) + (mx[2])) + (2);
          v[1][1] = &((*(this ))((pos) -(1)));
          v[1][0] = (v[1][1]) -((mx[2]) + (2));
          v[1][2] = ((v[1][1]) + (mx[2])) + (2);
          v[2][1] = &((*(this ))(((pos) + (((mx[2]) + (2)) * ((mx[1]) + (2)))) -(1)));
          v[2][0] = (v[2][1]) -((mx[2]) + (2));
          v[2][2] = ((v[2][1]) + (mx[2])) + (2);
          return ((((a[0]) * (v[1][1][1])) + ((a[1]) * ((((((v[0][1][1]) + (v[2][1][1])) + (v[1][0][1])) + (v[1][2][1])) + (v[1][1][0])) + (v[1][1][2])))) + ((a[2]) * ((((((((((((v[1][0][0]) + (v[1][0][2])) + (v[1][2][0])) + (v[1][2][2])) + (v[0][1][0])) + (v[0][1][2])) + (v[2][1][0])) + (v[2][1][2])) + (v[0][0][1])) + (v[0][2][1])) + (v[2][0][1])) + (v[2][2][1])))) + ((a[3]) * ((((((((v[0][0][0]) + (v[0][0][2])) + (v[0][2][0])) + (v[0][2][2])) + (v[2][0][0])) + (v[2][0][2])) + (v[2][2][0])) + (v[2][2][2])));
       }
public:
       void  loc_norm2u3();
public:
       void   set_value(int i0, int i1, int i2, double v){
       
          if (((((((start[0])<=(i0)) && ((i0)<=(stop[0]))) && ((start[1])<=(i1))) && ((i1)<=(stop[1]))) && ((start[2])<=(i2))) && ((i2)<=(stop[2]))) 
          {
             (*(this ))(i0,i1,i2) = v;
           }
        }
public:
       s_elem &  operator +=(s_elem &rhs){
       
          return *(this );
       }
 
};
struct INFO_HEAD {
       int LocalTraversalCount;
       char  *CurrentCollectionTraversal;
       int type;
       int number_dimension;
       int element_size;
       int nb_element;
       int dim1size,dim2size,dim3size;
       int  **Table;
       int  **Where;
} ;
typedef  struct INFO_HEAD *PTR_INFO;
typedef  struct  {
       int numproc;
       int numthread;
       int shmemsize;
       int stacksize;
} pCC_PARAM_t;
class  Processors {
public:
public:
       int dimension;
 
};
class  Distribution {
public:
public:
       int nbdim;
public:
       int nbelement;
public:
       int dim1size,dim2size,dim3size;
public:
       int dist1,dist2,dist3;
public:
       Processors P;
public:
        Distribution();
public:
        Distribution(int d1size, Processors *P, int dt1);
public:
        Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2);
public:
        Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3);
public:
       int GiveElementProc(int i);
public:
       int GiveElementProc(int i, int j);
public:
       int GiveElementProc(int i, int j, int k);
 
};
 Distribution:: Distribution(){

       nbdim = 1;
       nbelement = pcxx_TotalNodes();
       dim1size = pcxx_TotalNodes();
       dist1 = 2;
}
 Distribution:: Distribution(int d1size, Processors *P, int dt1){

       nbdim = 1;
       nbelement = d1size;
       dim1size = d1size;
       dist1 = dt1;
}
 Distribution:: Distribution(int d1size, int d2size, Processors *P, int dt1, int dt2){

       nbdim = 2;
       nbelement = (d1size) * (d2size);
       dim1size = d1size;
       dim2size = d2size;
       dist1 = dt1;
       dist2 = dt2;
}
 Distribution:: Distribution(int d1size, int d2size, int d3size, Processors *P, int dt1, int dt2, int dt3){

       nbdim = 2;
       nbelement = ((d1size) * (d2size)) * (d3size);
       dim1size = d1size;
       dim2size = d2size;
       dim3size = d3size;
       dist1 = dt1;
       dist2 = dt2;
       dist3 = dt3;
       Message("Distribution(): Sorry, 3D template not implemented.",1);
}
int Distribution:: GiveElementProc(int i){

       int proc = 0;
       int x,p,rem,q;
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          case 2:
          proc = (i)% (pcxx_TotalNodes());
          break;
          case 3:
          Message("GiveElementProc()_1D: WHOLE has no meaning in 1D Distribution,",0);
          Message("GiveElementProc()_1D: use BLOCK distribution instead.",0);
          p = (dim1size) / (pcxx_TotalNodes());
          rem = (dim1size) -((pcxx_TotalNodes()) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          proc = (i) / (q);
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             proc = ((pcxx_TotalNodes()) -(1)) -((proc)% (pcxx_TotalNodes()));
           }
           break;
          default:
          Message("GiveElementProc()_1D: Unknow distribution for 1D Distribution.",1);
        }
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_1D: Error in 1D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j){

       int proc = 0;
       int index1,index2,sq,p,rem,q;
       float x,y;
       if (((dist1) == (4)) && ((dist2) == (4))) 
       {
          q = (int) QGridToProc(i,j,dim1size);
          x = ((dim1size) * (dim2size)) / ((float) pcxx_TotalNodes());
          y = (q) / (x);
          proc = (int) y;
          if ((proc)>=(pcxx_TotalNodes())) 
          {
             Message("GiveElementProc()_2D: Processor # Out of Bounds)",0);
             proc = (proc)% (pcxx_TotalNodes());
           }
           return proc;
        }
        sq = (int) sqrt((double) pcxx_TotalNodes());
       switch (dist1)
       {
          case 1:
          p = (dim1size) / (sq);
          rem = (dim1size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index1 = (i) / (q);
          if ((index1)>=(sq)) 
          {
             index1 = ((sq) -(1)) -((index1)% (sq));
           }
           break;
          case 2:
          index1 = (i)% (sq);
          break;
          case 3:
          index1 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       switch (dist2)
       {
          case 1:
          p = (dim2size) / (sq);
          rem = (dim2size) -((sq) * (p));
          q = ((p)<=(rem))?(p) + (1):p;
          index2 = (j) / (q);
          if ((index2)>=(sq)) 
          {
             index2 = ((sq) -(1)) -((index2)% (sq));
           }
           break;
          case 2:
          index2 = (j)% (sq);
          break;
          case 3:
          index2 = 0;
          break;
          default:
          Message("GiveElementProc()_2D: Unknow distribution for 2D Distribution.",1);
        }
       proc = (index1) + ((index2) * (sq));
       if ((proc)>=(pcxx_TotalNodes())) 
       {
          Message("GiveElementProc()_2D: Error in 2D Distribution object.",0);
          proc = (proc)% (pcxx_TotalNodes());
        }
        return proc;
}
int Distribution:: GiveElementProc(int i, int j, int k){

       Message("GiveElementProc()_3D: Sorry, 3D template not implemented.",1);
       return 0;
}
class  Align {
public:
public:
       int nbelement;
public:
       int nbdim;
public:
       int dim1size,dim2size,dim3size;
public:
       int ret_index1;
public:
       int ret_index2;
public:
       int ret_index3;
public:
       int chosen;
public:
         Align(int i, int j, char *str){
       
       }
public:
         Align(int n1, int n2, int choix){
       
          nbdim = 2;
          dim1size = n1;
          dim2size = n2;
          nbelement = (n1) * (n2);
          chosen = choix;
       }
public:
         Align(int n1, int choix){
       
          nbdim = 1;
          dim1size = n1;
          dim2size = 0;
          nbelement = n1;
          chosen = choix;
       }
public:
       void  align_func(int var_i, int var_j);
 
};
class  Kernel {
public:
public:
       Distribution  *Tmp;
public:
       Align  *align;
       struct INFO_HEAD GlobalInfo;
public:
       int CollectionNumber;
public:
       int CollectionNumber_Type;
public:
       int  *buffer;
public:
        Kernel(Distribution *T, Align *A, int sizelem);
public:
        Kernel(Kernel *col);
public:
        ~Kernel();
public:
       int Is_Local(int index);
public:
       int Is_Local(int index1, int index2);
public:
       int GlobalIndex(int i);
public:
       int GlobalIndex(int i, int j);
public:
       int Get_2DHighIndex(int index);
public:
       int Get_2DLowIndex(int index);
public:
       int AllocatedProc(int index);
public:
       int AllocatedProc(int index1, int index2);
public:
       int Install_Collection(Distribution *T, Align *A, int sizeelem);
public:
       int  *Get_Element(int index);
public:
       int  *Get_Element(int index1, int index2);
public:
       int  *Get_ElementPart(int index, int startof, int size);
public:
       int  *Get_ElementPart(int index1, int index2, int startof, int size);
public:
       int Get_ElementPart_Int(int index1, int startof);
public:
       float Get_ElementPart_Float(int index1, int startof);
public:
       double Get_ElementPart_Double(int index1, int startof);
public:
       int Get_ElementPart_Int(int index1, int index2, int startof);
public:
       float Get_ElementPart_Float(int index1, int index2, int startof);
public:
       double Get_ElementPart_Double(int index1, int index2, int startof);
public:
       int  *Get_CopyElem(int index);
public:
       int  *Get_CopyElem(int index1, int index2);
public:
       void  Fetch_Element(int index, int *buf, int startof, int size);
 
};
int Kernel:: AllocatedProc(int index){

       int proc = 0;
       (align)->align_func(index,0);
       if (((Tmp)->nbdim) == (1)) 
       {
          proc = (Tmp)->GiveElementProc((align)->ret_index1);
        }
        else{
          proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
        }
       return proc;
}
int Kernel:: AllocatedProc(int index1, int index2){

       int proc = 0;
       (align)->align_func(index1,index2);
       proc = (Tmp)->GiveElementProc((align)->ret_index1,(align)->ret_index2);
       return proc;
}
int Kernel:: GlobalIndex(int index){

       return index;
}
int Kernel:: GlobalIndex(int index1, int index2){

       return (index1) + ((index2) * (GlobalInfo.dim1size));
}
int Kernel:: Get_2DHighIndex(int index){

       return (index) / (GlobalInfo.dim1size);
}
int Kernel:: Get_2DLowIndex(int index){

       return (index)% (GlobalInfo.dim1size);
}
int Kernel:: Is_Local(int index){

       if ((GlobalInfo.Table[GlobalIndex(index)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
int Kernel:: Is_Local(int index1, int index2){

       if ((GlobalInfo.Table[GlobalIndex(index1,index2)]) == ((int *) 0)) 
       {
          return 0;
        }
        else{
          return 1;
        }
}
 Kernel:: Kernel(Distribution *T, Align *A, int sizelem){

       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       if (((A)->nbelement) >  ((T)->nbelement)) 
       {
          Message("Kernel(): Elements in Align are more than elements in Distribution.",0);
        }
        GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        _pcxx_Barrier();
}
 Kernel:: Kernel(Kernel *col){

       Distribution  *T;
       Align  *A;
       int sizelem;
       int i;
       if ( !(col)) 
       {
          Message("Kernel(): Collection not provided.",1);
        }
        T = (col)->Tmp;
       A = (col)->align;
       sizelem = (col)->GlobalInfo.element_size;
       if (( !(T)) || ( !(A))) 
       {
          Message("Kernel(): No alignement or template provided.",1);
        }
        Tmp = T;
       align = A;
       GlobalInfo.type =  (-(1));
       GlobalInfo.number_dimension = (A)->nbdim;
       GlobalInfo.element_size = sizelem;
       GlobalInfo.nb_element = (A)->nbelement;
       GlobalInfo.dim1size = (A)->dim1size;
       GlobalInfo.dim2size = (A)->dim2size;
       GlobalInfo.dim3size = (A)->dim3size;
       if ( !(Install_Collection(T,A,sizelem))) 
       {
          Message("Kernel(): Error in creating collection.",1);
        }
        for (i = 0 ; (i) < (GlobalInfo.nb_element) ; (i)++)
       {
          if ((GlobalInfo.Table[i]) && ((col)->GlobalInfo.Table[i])) 
          {
             bcopy((char *) (col)->GlobalInfo.Table[i],(char *) GlobalInfo.Table[i],sizelem);
           }
         }
       _pcxx_Barrier();
}
void  Kernel:: Fetch_Element(int index, int *buf, int startof, int size){

       int wh,offset;
       int data1,data2,data3,data4;
       int cs;
       int  *pt;
       if ((GlobalInfo.Table[index])!=(0)) 
       {
          pt = GlobalInfo.Table[index];
        }
        else{
          pt = (int *) GlobalInfo.Where[index];
        }
       if ( !(pt)) 
       {
          Message("Element not found",0);
        }
        if (((size)!=( (-(1)))) || ((GlobalInfo.element_size)<=(16))) 
       {
          cs = size;
        }
        if ((size) == ( (-(1)))) 
       {
          cs = (GlobalInfo.element_size) / (sizeof (int) );
        }
        else{
          cs = size;
        }
       for (offset = startof ; (offset) < ((cs) + (startof)) ; offset = (offset) + (4))
       {
          buf[(offset) -(startof)] = pt[offset];
          buf[((offset) -(startof)) + (1)] = pt[(offset) + (1)];
          buf[((offset) -(startof)) + (2)] = pt[(offset) + (2)];
          buf[((offset) -(startof)) + (3)] = pt[(offset) + (3)];
        }
}
int * Kernel:: Get_Element(int index){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_Element(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_Element_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index)];
        }
}
int * Kernel:: Get_Element(int index1, int index2){

       int wh,offset;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_Element_2D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        else{
          return (int *) GlobalInfo.Where[GlobalIndex(index1,index2)];
        }
}
int * Kernel:: Get_ElementPart(int index, int startof, int size){

       int wh,offset;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_ElementPart(Get_2DLowIndex(index),Get_2DHighIndex(index),startof,size);
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_1D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index)]) + (startof);
        }
}
int * Kernel:: Get_ElementPart(int index1, int index2, int startof, int size){

       int wh,offset;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_2D: Error in loading local element.",1);
           }
           return (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof);
        }
        else{
          return ((int *) GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof);
        }
}
int Kernel:: Get_ElementPart_Int(int index, int startof){

       int wh,offset;
       if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Int_1D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index, int startof){

       int wh,offset;
       if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Float_1D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index, int startof){

       int wh,offset;
       if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_ElementPart_Double_1D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index)]) + (startof));
        }
}
int Kernel:: Get_ElementPart_Int(int index1, int index2, int startof){

       int wh,offset;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Int_2D: Error in loading local element.",1);
           }
           return (int) *((int *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (int) *((int *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
float Kernel:: Get_ElementPart_Float(int index1, int index2, int startof){

       int wh,offset;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Float_2D: Error in loading local element.",1);
           }
           return (float) *((float *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (float) *((float *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
double Kernel:: Get_ElementPart_Double(int index1, int index2, int startof){

       int wh,offset;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_ElementPart_Double_2D: Error in loading local element.",1);
           }
           return (double) *((double *) (GlobalInfo.Table[GlobalIndex(index1,index2)]) + (startof));
        }
        else{
          return (double) *((double *) (GlobalInfo.Where[GlobalIndex(index1,index2)]) + (startof));
        }
}
int * Kernel:: Get_CopyElem(int index){

       int wh,offset;
       int  *NBuf;
       if ((GlobalInfo.number_dimension) == (2)) 
       {
          return Get_CopyElem(Get_2DLowIndex(index),Get_2DHighIndex(index));
        }
        if (Is_Local(index)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index)])) 
          {
             Message("Get_CopyElem_1D: Error in loading local element.",1);
           }
           return GlobalInfo.Table[GlobalIndex(index)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index),NBuf,0, (-(1)));
       return NBuf;
}
int * Kernel:: Get_CopyElem(int index1, int index2){

       int wh,offset;
       int  *NBuf;
       if (Is_Local(index1,index2)) 
       {
          if ( !(GlobalInfo.Table[GlobalIndex(index1,index2)])) 
          {
             Message("Get_CopyElem_2D: Error in loading local element",1);
           }
           return GlobalInfo.Table[GlobalIndex(index1,index2)];
        }
        NBuf = new int [((GlobalInfo.element_size) / (sizeof(int ))) + (4)] ;
       Fetch_Element(GlobalIndex(index1,index2),NBuf,0, (-(1)));
       return NBuf;
}
int Kernel:: Install_Collection(Distribution *T, Align *A, int sizeelem){

       int i,j;
       int proc;
       int count;
       int  *allocated;
       int  **ElemAllocVector;
       CollectionNumber = GetNumberOfCollection();
       IncNumberOfCollection();
       GlobalInfo.Table = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Table) == (0)) 
       {
          Message("Install_Collection: unable to allocate space.",1);
        }
        GlobalInfo.Where = (int **) malloc(((A)->nbelement) * (sizeof (int *) ));
       if ((GlobalInfo.Where) == (0)) 
       {
          Message("Install_Collection : unable to allocate space",1);
        }
        SetTableOfCollection(CollectionNumber,(char *) &(GlobalInfo));
       buffer = new int [((sizeelem) / (sizeof(int ))) + (4)] ;
       if (((A)->nbelement) == (0)) 
       {
          Message("No Element in the collection",1);
        }
        count = 0;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((AllocatedProc(i)) == (pcxx_NodeNumber())) 
             {
                (count)++;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((AllocatedProc(i,j)) == (pcxx_NodeNumber())) 
                   {
                      (count)++;
                    }
                  }
              }
           }
           else{
             if ((GlobalInfo.number_dimension) >  (2)) 
             {
                Message("Install_Collection(): 3D implementation not available.",1);
              }
            }
        }
       AweAllocElemSpace(pcxx_NodeNumber(),(count) * ((sizeelem) + ((4) * (sizeof (int) ))));
       _pcxx_Barrier();
       ElemAllocVector = (int **) malloc((pcxx_TotalNodes()) * (sizeof (int *) ));
       for (i = 0 ; (i) < (pcxx_TotalNodes()) ; (i)++)
       {
          ElemAllocVector[i] = (int *) AweGetElemSpacePtr(i);
        }
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             proc = AllocatedProc(i);
             allocated = ElemAllocVector[proc];
             ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
             if ((proc) == (pcxx_NodeNumber())) 
             {
                GlobalInfo.Table[GlobalIndex(i)] = allocated;
                GlobalInfo.Where[GlobalIndex(i)] = (int *) 0;
              }
              else{
                GlobalInfo.Table[GlobalIndex(i)] = (int *) 0;
                GlobalInfo.Where[GlobalIndex(i)] = allocated;
              }
           }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   proc = AllocatedProc(i,j);
                   allocated = ElemAllocVector[proc];
                   ElemAllocVector[proc] += ((sizeelem) / (sizeof (int) )) + (4);
                   if ((proc) == (pcxx_NodeNumber())) 
                   {
                      GlobalInfo.Table[GlobalIndex(i,j)] = allocated;
                      GlobalInfo.Where[GlobalIndex(i,j)] = (int *) 0;
                    }
                    else{
                      GlobalInfo.Table[GlobalIndex(i,j)] = (int *) 0;
                      GlobalInfo.Where[GlobalIndex(i,j)] = allocated;
                    }
                 }
              }
           }
         }
       free(ElemAllocVector);
       _pcxx_Barrier();
       return 1;
}
 Kernel:: ~Kernel(){

       int found;
       int i,j;
       SetTableOfCollection(CollectionNumber,(char *) 0);
       delete  buffer;
       if ((GlobalInfo.number_dimension) == (1)) 
       {
          for (i = 0 ; (i) < (GlobalInfo.dim1size) ; (i)++)
          {
             if ((GlobalInfo.Table[GlobalIndex(i)])!=(0)) 
             {
                AweDealloc(GlobalInfo.Table[GlobalIndex(i)]);
                break;
              }
            }
        }
        else{
          if ((GlobalInfo.number_dimension) == (2)) 
          {
             found = 0;
             for (i = 0 ; ((i) < (GlobalInfo.dim1size)) && ( !(found)) ; (i)++)
             {
                for (j = 0 ; (j) < (GlobalInfo.dim2size) ; (j)++)
                {
                   if ((GlobalInfo.Table[GlobalIndex(i,j)])!=(0)) 
                   {
                      AweDealloc(GlobalInfo.Table[GlobalIndex(i,j)]);
                      found = 1;
                      break;
                    }
                  }
              }
           }
         }
       _pcxx_Barrier();
       free(GlobalInfo.Where);
       free(GlobalInfo.Table);
}
int  GetFirstLocalElementIndex(Kernel *p){

       Kernel  *pt;
       int i;
       pt = (Kernel *) p;
       for (i = 0 ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             return i;
           }
         }
       return  (-(1));
}
void   ResetLocal(Kernel *p){

       (p)->GlobalInfo.LocalTraversalCount = 0;
       SetNextCollectionTraversalLevel((char *) p);
}
int  Local(int elem){

       Kernel  *pt;
       int i;
       pt = (Kernel *) GetCollectionTraversalLevel();
       if (((pt)->GlobalInfo.LocalTraversalCount) >  ((pt)->GlobalInfo.nb_element)) 
       {
          DecCollectionTraversalLevel();
          return  (-(1));
        }
        for (i = (pt)->GlobalInfo.LocalTraversalCount ; (i) < ((pt)->GlobalInfo.nb_element) ; (i)++)
       {
          if (((pt)->GlobalInfo.Table[i])!=(0)) 
          {
             (pt)->GlobalInfo.LocalTraversalCount = (i) + (1);
             return i;
           }
         }
       DecCollectionTraversalLevel();
       return  (-(1));
}
int  FirstLocal(){

       return Local(0);
}
int  FirstInSubset(Kernel *coll, int lb, int ub, int step){

       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((lb) == ( (-(1)))) 
       {
          return 0;
        }
        if ((lb)<=(ub)) 
       {
          return lb;
        }
        return  (-(1));
}
int  NextInSubset(Kernel *coll, int lb, int ub, int step, int var){

       int bsup;
       if ( !(coll)) 
       {
          return  (-(1));
        }
        if ((ub) == ( (-(1)))) 
       {
          bsup = (coll)->GlobalInfo.dim1size;
        }
        else{
          bsup = ub;
        }
       if (((var) + (step))<=(bsup)) 
       {
          return (var) + (step);
        }
        else{
          return  (-(1));
        }
}
  CheckLocal(Kernel *coll, int index){

       if ( !(coll)) 
       {
          return 0;
        }
        return (coll)->Is_Local(index);
}
class  SuperKernel__s_elem: public Kernel {
public:
       int dim1size;
       int dim2size;
        SuperKernel__s_elem(Distribution *T, Align *A);
       s_elem  *operator ()(int i1);
       s_elem  *operator ()(int i1, int i2);
 
};
s_elem * SuperKernel__s_elem:: operator ()(int i1){

       s_elem  *pt;
       pt = (s_elem *) Get_Element(i1);
       return pt;
}
s_elem * SuperKernel__s_elem:: operator ()(int i1, int i2){

       s_elem  *pt;
       pt = (s_elem *) Get_Element(i1,i2);
       return pt;
}
 SuperKernel__s_elem:: SuperKernel__s_elem(Distribution *T, Align *A):Kernel(T,A,sizeof (s_elem) ){

       int i,j;
       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        dim1size = (A)->dim1size;
       dim2size = (A)->dim2size;
       if (((A)->nbdim) == (1)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             if (Is_Local(i)) 
             {
                ((*(this ))(i))->index1 = i;
                ((*(this ))(i))->index2 = 0;
                ((*(this ))(i))->ThisCollection = (SuperKernel__s_elem *) this ;
                ((*(this ))(i))->Ident = (((this )->CollectionNumber) * (16777216)) + (i);
              }
            }
          _pcxx_Barrier();
        }
        if (((A)->nbdim) == (2)) 
       {
          for (i = 0 ; (i) < (dim1size) ; (i)++)
          {
             for (j = 0 ; (j) < (dim2size) ; (j)++)
             {
                if (Is_Local(i,j)) 
                {
                   ((*(this ))(i,j))->index1 = i;
                   ((*(this ))(i,j))->index2 = j;
                   ((*(this ))(i,j))->ThisCollection = (SuperKernel__s_elem *) this ;
                   ((*(this ))(i))->Ident = ((((this )->CollectionNumber) * (16777216)) + (i)) + ((j) * ((this )->dim1size));
                 }
               }
           }
          _pcxx_Barrier();
        }
        if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional collection not implemented.",1);
        }
 }
s_elem * s_elem:: Self(int i){

       return (s_elem *) (ThisCollection)->Get_Element((index1) + (i));
}
s_elem * s_elem:: Self(int i, int j){

       return (s_elem *) (ThisCollection)->Get_Element((index1) + (i),(index2) + (j));
}
class  DistributedArray__s_elem: public SuperKernel__s_elem {
public:
       int blocksize;
        DistributedArray__s_elem(Distribution *T, Align *A);
        DistributedArray__s_elem(Kernel *coll);
       void  Assign(int i1, s_elem &e);
       void  Assign(int i1, int i2, s_elem &e);
       DistributedArray__s_elem  &operator =(DistributedArray__s_elem &rhs);
       void  Shift(int dim, int distance);
       void  Reduce();
       void  ReduceDim1();
       void  ReduceDim2();
       void  Broadcast();
       void  BroadcastDim1();
       void  BroadcastDim2();
       double DotProd(DistributedArray__s_elem &arg1);
 
};
 DistributedArray__s_elem:: DistributedArray__s_elem(Distribution *T, Align *A):SuperKernel__s_elem(T,A){

       if (( !(T)) || ( !(A))) 
       {
          Message("No alignment or template for collection initialization.",1);
        }
        blocksize = 0;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->Set_ThisCollection(this );
        }
       _pcxx_Barrier();
       if (((A)->nbdim)>=(3)) 
       {
          Message("3D and higher-dimensional DistributedArray not implemented.",1);
        }
 }
void  DistributedArray__s_elem:: Shift(int dim, int distance){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep1(dim,distance);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalShiftStep2();
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->DeleteTemp();
        }
       _pcxx_Barrier();
}
void  s_elem:: LocalShiftStep1(int dim, int distance){

       int elem;
       s_elem  *pt;
       double  *ptc,*pte;
       int i,size;
       if ((dim) == (1)) 
       {
          elem = (index1) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim1size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim1size);
              }
           }
          if ((ThisCollection)->Is_Local(elem,index2)) 
          {
             pt = (s_elem *) (ThisCollection)->Get_Element(elem,index2);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (s_elem *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (s_elem *) (ThisCollection)->Get_CopyElem(elem,index2);
           }
        }
        else{
          elem = (index2) + (distance);
          if ((elem)>=(0)) 
          {
             elem = (elem)% ((ThisCollection)->dim2size);
           }
           else{
             while ((elem) < (0))
             {
                elem = (elem) + ((ThisCollection)->dim2size);
              }
           }
          if ((ThisCollection)->Is_Local(index1,elem)) 
          {
             pt = (s_elem *) (ThisCollection)->Get_Element(index1,elem);
             size = ((ThisCollection)->GlobalInfo.element_size) / (sizeof (double) );
             (this )->temporaryelement = (s_elem *) new double [(size) + (1)] ;
             ptc = (double *) (this )->temporaryelement;
             pte = (double *) pt;
             for (i = 0 ; (i)<=(size) ; (i)++)
             {
                *((ptc)++) = *((pte)++);
              }
           }
           else{
             (this )->temporaryelement = (s_elem *) (ThisCollection)->Get_CopyElem(index1,elem);
           }
        }
}
void  s_elem:: LocalShiftStep2(){

       *(this ) = *((this )->temporaryelement);
}
void  s_elem:: DeleteTemp(){

       delete  (this )->temporaryelement;
       (this )->temporaryelement = 0;
}
void  s_elem:: Set_ThisCollection(DistributedArray__s_elem *C){

       (this )->ThisCollection = C;
}
void  s_elem:: WhereAmI(){

       printf("Element (%d, %d) on processor %d\n",index1,index2,pcxx_NodeNumber());
       _pcxx_Barrier();
}
void  DistributedArray__s_elem:: Assign(int i1, s_elem &e){

       if ((this )->Is_Local(i1)) 
       {
          *((*(this ))(i1)) = e;
        }
 }
void  DistributedArray__s_elem:: Assign(int i1, int i2, s_elem &e){

       if ((this )->Is_Local(i1,i2)) 
       {
          *((*(this ))(i1,i2)) = e;
        }
 }
void  DistributedArray__s_elem:: Reduce(){

       int steps = 1;
       int borne;
       if (dim2size) 
       {
          borne = (dim1size) * (dim2size);
        }
        else{
          borne = dim1size;
        }
       while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduce(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__s_elem:: ReduceDim1(){

       int steps = 1;
       while ((steps) < (dim1size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim1(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  DistributedArray__s_elem:: ReduceDim2(){

       int steps = 1;
       while ((steps) < (dim2size))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalReduceDim2(this ,steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
}
void  s_elem:: LocalReduce(DistributedArray__s_elem *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((ind) + (step)));
        }
 }
void  s_elem:: LocalReduceDim1(DistributedArray__s_elem *array, int step){

       if (((index1)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))((index1) + (step),index2));
        }
 }
void  s_elem:: LocalReduceDim2(DistributedArray__s_elem *array, int step){

       if (((index2)% ((2) * (step))) == (0)) 
       {
          *(this ) += *((*(array))(index1,(index2) + (step)));
        }
 }
void  DistributedArray__s_elem:: Broadcast(){

       int steps;
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__s_elem:: BroadcastDim1(){

       int steps = (dim1size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim1(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  DistributedArray__s_elem:: BroadcastDim2(){

       int steps = (dim2size) / (2);
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcastDim2(this ,steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
}
void  s_elem:: LocalBroadcast(DistributedArray__s_elem *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((ind) -(step)));
        }
 }
void  s_elem:: LocalBroadcastDim1(DistributedArray__s_elem *array, int step){

       if (((index1) && (((index1)% (step)) == (0))) && ( !(((index1)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))((index1) -(step),index2));
        }
 }
void  s_elem:: LocalBroadcastDim2(DistributedArray__s_elem *array, int step){

       if (((index2) && (((index2)% (step)) == (0))) && ( !(((index2)% ((2) * (step))) == (0)))) 
       {
          *(this ) = *((*(array))(index1,(index2) -(step)));
        }
 }
DistributedArray__s_elem & DistributedArray__s_elem:: operator =(DistributedArray__s_elem &rhs){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalCopy(&(rhs));
        }
       _pcxx_Barrier();
       return *(this );
}
void  s_elem:: LocalCopy(DistributedArray__s_elem *array){

       *(this ) = *((*(array))(index1,index2));
}
double DistributedArray__s_elem:: DotProd(DistributedArray__s_elem &arg1){

       double total;
       int steps = 1;
       int locali;
       s_elem dummy;
       int  *addr1,*addr2;
       int borne;
       double  *tmp;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetDotProd(arg1);
        }
       _pcxx_Barrier();
       borne = dim1size;
       if (dim2size) 
       {
          borne = (borne) * (dim2size);
        }
        while ((steps) < (borne))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalGSum(*(this ),steps);
           }
          _pcxx_Barrier();
          steps = (steps) * (2);
        }
       if (dim2size) 
       {
          steps = ((dim1size) * (dim2size)) / (2);
        }
        else{
          steps = (dim1size) / (2);
        }
       while (steps)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->BroadcastTemp(*(this ),steps);
           }
          _pcxx_Barrier();
          if ((steps) == (1)) 
          {
             break;
           }
           steps = (steps) / (2);
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          total = ((*(this ))(locali))->dotprodtemp;
        }
        else{
          addr1 = (int *) &(dummy);
          addr2 = (int *) &(dummy.dotprodtemp);
          tmp = (double *) (this )->Get_ElementPart((pcxx_NodeNumber())% ((this )->dim1size),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          total = *(tmp);
        }
       _pcxx_Barrier();
       return total;
}
void  s_elem:: LocalGSum(DistributedArray__s_elem &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind)% ((2) * (step))) == (0)) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          s_elem  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) + (step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          dotprodtemp += *(tmp);
        }
 }
void  s_elem:: BroadcastTemp(DistributedArray__s_elem &array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          int  *addr1,*addr2;
          double  *tmp;
          s_elem  *x;
          addr1 = (int *) this ;
          addr2 = (int *) &((this )->dotprodtemp);
          tmp = (double *) array.Get_ElementPart((ind) -(step),(addr2) -(addr1),(sizeof (double) ) / (sizeof (int) ));
          (this )->dotprodtemp = *(tmp);
        }
 }
void  s_elem:: ResetDotProd(DistributedArray__s_elem &arg1){

       dotprodtemp = (this )->Dot(*((arg1)(index1,index2)));
}
class  Gr__s_elem: public DistributedArray__s_elem {
public:
       int n[3];
        Gr__s_elem(Distribution *T, Align *A, int _m1, int _m2, int _m3);
        Gr__s_elem(Gr__s_elem &finer);
        ~Gr__s_elem();
       void  zran3();
       void  resid(Gr__s_elem &u, Gr__s_elem &v);
       void  rprj3(Gr__s_elem &r);
       void  interp(Gr__s_elem &z);
       void  psinv(Gr__s_elem &r);
       void  norm2u3(double &rnm2, double &rnmu);
       void  spread();
       void  comm3();
       void  spread_and_comm3();
 
};
double s_elem:: Dot(s_elem arg1){

       return 0;
}
typedef  Gr__s_elem  *pGr;
typedef  Gr__s_elem  &rGr;
static s_elem dummy;
inline s_elem &  elf(Gr__s_elem &G, int i1, int i2){

       s_elem  *e = (s_elem *) G.Get_Element(i1,i2);
       return *(e);
}
void  s_elem:: dev1(){

       int i;
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          mx[i] = (((pGr) ThisCollection)->n[i]) / (dimsize[i]);
          if (((mx[i]) * (dimsize[i])) < (((pGr) ThisCollection)->n[i])) 
          {
             (mx[i])++;
           }
         }
}
 Gr__s_elem:: Gr__s_elem(Distribution *T, Align *A, int _n1, int _n2, int _n3):DistributedArray__s_elem(T,A){

       n[0] = _n1;
       n[1] = _n2;
       n[2] = _n3;
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->dev1();
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->init_elem();
        }
       _pcxx_Barrier();
}
void  s_elem:: dev2(Gr__s_elem &G){

       int i;
       s_elem  &e = elf(G,index1,index2);
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          mx[i] = ((e.mx[i]) / (2)) + (1);
        }
}
 Gr__s_elem:: Gr__s_elem(Gr__s_elem &G):DistributedArray__s_elem(G.Tmp,G.align){

       int i;
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          n[i] = ((G.n[i]) / (2)) + (1);
        }
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->dev2(G);
        }
       _pcxx_Barrier();
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->coarser_elem(G);
        }
       _pcxx_Barrier();
}
void  s_elem:: init_elem(){

       int index[3],i;
       int _start[3],_stop[3];
       s_elem  &e = *this ;
       index[0] = index1;
       index[1] = index2;
       index[2] = 0;
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          int m,excess;
          m = (((pGr) ThisCollection)->n[i]) / (dimsize[i]);
          excess = (((pGr) ThisCollection)->n[i]) -((m) * (dimsize[i]));
          has_neighbor[0][i] = (index[i]) >  (0);
          has_neighbor[1][i] = (index[i]) < ((dimsize[i]) -(1));
          _start[i] = ((index[i]) * (m)) + (((index[i]) >  (excess))?excess:index[i]);
          _stop[i] = (((_start[i]) + (m)) -(1)) + ((index[i]) < (excess));
          if ((_stop[i])>=(((pGr) ThisCollection)->n[i])) 
          {
             printf("%s\n","_stop[i] >= n[i]\n");
             exit(1);
           }
           if ( !(has_neighbor[0][i])) 
          {
             (_start[i])++;
           }
           if ( !(has_neighbor[1][i])) 
          {
             (_stop[i])--;
           }
           if ((_start[i]) >  (_stop[i])) 
          {
             printf("%s\n","Empty chunk (the finest grid contains too few elements)\n");
             exit(1);
           }
         }
       e.s_elem(_start,_stop);
}
void  s_elem:: coarser_elem(Gr__s_elem &G){

       int index[3],i,j;
       int _start[3],_stop[3];
       s_elem  *q;
       s_elem  &e = *this ;
       q = (s_elem *) G.Get_Element(index1,index2);
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          for (j = 0 ; (j) < (2) ; (j)++)
          {
             has_neighbor[j][i] = (q)->has_neighbor[j][i];
           }
          _start[i] = (((q)->start[i]) + (1)) / (2);
          _stop[i] = (has_neighbor[1][i])?((q)->stop[i]) / (2):(((q)->stop[i]) + (1)) / (2);
          if ((_stop[i]) < (_start[i])) 
          {
             printf("%s\n","Coarser-elem: Empty chunk (a coarse grid has too few elements)");
             exit(1);
           }
         }
       e.s_elem(_start,_stop);
}
 Gr__s_elem:: ~Gr__s_elem(){

       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->elem_destructor();
        }
       _pcxx_Barrier();
}
void   coarse_grids(pGr u[(lm) + (1)]){

       int k;
       for (k = (lt) -(1) ; (k)>=(lb) ; (k)--)
       {
          u[k] = new Gr__s_elem (*(u[(k) + (1)]));
        }
       return ;
}
void  s_elem:: surf2buf(int dir, int side, int mode){

       int i[3],ind1,ind2;
       if ( !(mode&1 << has_neighbor[side][dir])) 
       {
          return ;
        }
        ind1 = ((dir) == (0))?1:0;
       ind2 = (ind1) + (1);
       if ((ind2) == (dir)) 
       {
          (ind2)++;
        }
        i[dir] = (side)?stop[dir]:start[dir];
       int  &i1 = i[ind1],&i2 = i[ind2];
       int bufcount = 0;
       for (i1 = (start[ind1]) -(1) ; (i1)<=((stop[ind1]) + (1)) ; (i1)++)
       {
          for (i2 = (start[ind2]) -(1) ; (i2)<=((stop[ind2]) + (1)) ; (i2)++)
          {
             sidebuf[(bufcount)++] = (*(this ))(i);
           }
        }
}
void  s_elem:: surf_from_buf(int dir, int side, int mode){

       int k[3];
       if ( !(mode&1 << has_neighbor[side][dir])) 
       {
          return ;
        }
        k[0] = index1;
       k[1] = index2;
       k[2] = 0;
       k[dir] = ((k[dir]) + ((side)?1:(dimsize[dir]) -(1)))% (dimsize[dir]);
       int i[3],ind1,ind2;
       ind1 = ((dir) == (0))?1:0;
       ind2 = (ind1) + (1);
       if ((ind2) == (dir)) 
       {
          (ind2)++;
        }
        i[dir] = (side)?(stop[dir]) + (1):(start[dir]) -(1);
       int  &i1 = i[ind1],&i2 = i[ind2];
       int act_bufs = (((stop[ind1]) -(start[ind1])) + (3)) * (((stop[ind2]) -(start[ind2])) + (3));
       double  *b = (double *) (ThisCollection)->Get_ElementPart(k[0],k[1],(((int) &dummy.sidebuf) -((int) &dummy)) / (sizeof (int) ),((sizeof (double) ) * (act_bufs)) / (sizeof (int) ));
       int bufcount = 0;
       for (i1 = (start[ind1]) -(1) ; (i1)<=((stop[ind1]) + (1)) ; (i1)++)
       {
          for (i2 = (start[ind2]) -(1) ; (i2)<=((stop[ind2]) + (1)) ; (i2)++)
          {
             (*(this ))(i) = b[(bufcount)++];
           }
        }
}
void  Gr__s_elem:: spread_and_comm3(){

       int i,j;
       pcxx_UserTimerStart(COMM);
       for (i = 0 ; (i) < (3) ; (i)++)
       {
          for (j = 0 ; (j) < (2) ; (j)++)
          {
             ResetLocal(this );
             for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
             {
                pcxx_Poll();
                ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->surf2buf(i,j,3);
              }
             _pcxx_Barrier();
             ResetLocal(this );
             for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
             {
                pcxx_Poll();
                ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->surf_from_buf(i, !(j),3);
              }
             _pcxx_Barrier();
           }
        }
       pcxx_UserTimerStop(COMM);
}
void  s_elem:: who_is_myproc(){

       myproc = pcxx_NodeNumber();
}
void  mg3P(Gr__s_elem &v, pGr u[(lm) + (1)], pGr r[(lm) + (1)]);
void   Processor_Main(){

       Processors mach;
       const int nit = 12;
       const logical trace = 1;
       double rnm2,rnmu,old2,oldu;
       integer it,n;
       n = nm;
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("Start!\n");
        }
        Distribution T(dimsize[0],dimsize[1],&mach,1,1);
       Align A(dimsize[0],dimsize[1],0);
       Gr__s_elem v(&T,&A,nm,nm,nm);
       pGr u[(lm) + (1)],r[(lm) + (1)];
       pGr tmp;
       u[lm] = new Gr__s_elem (&(T),&(A),nm,nm,nm);
       r[lm] = new Gr__s_elem (&(T),&(A),nm,nm,nm);
       coarse_grids(u);
       coarse_grids(r);
       pcxx_UserTimerClear(1);
       pcxx_UserTimerClear(2);
       pcxx_UserTimerClear(3);
       pcxx_UserTimerClear(4);
       pcxx_UserTimerClear(5);
       pcxx_UserTimerClear(6);
       pcxx_UserTimerClear(7);
       ResetLocal(&(v));
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((v)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->who_is_myproc();
        }
       _pcxx_Barrier();
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("\n Kernel B:  Solving a Poisson problem on a ");
          printf("%3d by %3d by %3d grid\n",(n) -(2),(n) -(2),(n) -(2));
          printf(" using %1d multigrid iterations\n\n",nit);
          char name[64];
          gethostname(name,64);
          printf("Machine `%s'\n",name);
          printf("%2d x %2d x %2d Distribution",dimsize[0],dimsize[1],dimsize[2]);
          printf(" on the following processors:\n");
          int i0,i1;
          for (i0 = 0 ; (i0) < (dimsize[0]) ; (i0)++)
          {
             printf("(");
             for (i1 = 0 ; (i1) < (dimsize[1]) ; (i1)++)
             {
                printf("%3d",*((int *) v.Get_ElementPart(i0,i1,(((int) &(dummy.myproc)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.myproc) / (sizeof (int) ))));
              }
             printf(" )\n");
           }
        }
        pcxx_UserTimerStart(TOTAL);
       {
          Gr__s_elem  &_ref = *u[lt];
          ResetLocal(&(_ref));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((_ref)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->zero3();
           }
          _pcxx_Barrier();
        }
       v.zran3();
       (r[lt])->resid(*(u[lt]),v);
       (r[lt])->norm2u3(rnm2,rnmu);
       old2 = rnm2;
       oldu = rnmu;
       pcxx_UserTimerStop(TOTAL);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf("\n it    L2-norm(R)         unif-norm(R)\n");
        }
        _pcxx_Barrier();
       pcxx_UserTimerStart(TOTAL);
       char format6[] = "%4d  %19.12e  %19.12e\n";
       for (it = 0 ; (it) < (nit) ; (it)++)
       {
          if (trace) 
          {
             (r[lt])->norm2u3(rnm2,rnmu);
             pcxx_UserTimerStop(TOTAL);
             if ((pcxx_NodeNumber()) == (0)) 
             {
                printf(format6,it,rnm2,rnmu);
              }
              _pcxx_Barrier();
             pcxx_UserTimerStart(TOTAL);
           }
           mg3P(v,u,r);
          (r[lt])->resid(*(u[lt]),v);
        }
       pcxx_UserTimerStop(TOTAL);
       (r[lt])->norm2u3(rnm2,rnmu);
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf(format6,nit,rnm2,rnmu);
        }
        if ((pcxx_NodeNumber()) == (0)) 
       {
          double temps,total = 0;
          int i;
          total = pcxx_UserTimerElapsed(TOTAL);
          for (i = 1 ; (i) < (8) ; (i)++)
          {
             temps = pcxx_UserTimerElapsed(i);
             printf("Elapsed time (%-14s) =%11.6f  (%4.1f%%)\n",deb_str[i],temps,((temps) * (100.0)) / (total));
           }
        }
        _pcxx_Barrier();
}
void   mg3P(Gr__s_elem &v, pGr u[(lm) + (1)], pGr r[(lm) + (1)]){

       int k;
       if ((lb) >  (lt)) 
       {
          printf("%s\n","lb>lt\n");
          exit(1);
        }
        else{
          if ((lb) == (lt)) 
          {
             (u[k])->psinv(*(r[k]));
             return ;
           }
         }
       for (k = lt ; (k) >  (lb) ; (k)--)
       {
          (r[(k) -(1)])->rprj3(*(r[k]));
        }
       k = lb;
       {
          Gr__s_elem  &_ref = *u[k];
          ResetLocal(&(_ref));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((_ref)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->zero3();
           }
          _pcxx_Barrier();
        }
       (u[k])->psinv(*(r[k]));
       for (k = (lb) + (1) ; (k) < (lt) ; (k)++)
       {
          Gr__s_elem  &_ref = *u[k];
          ResetLocal(&(_ref));
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((_ref)((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->zero3();
           }
          _pcxx_Barrier();
          (u[k])->interp(*(u[(k) -(1)]));
          (r[k])->resid(*(u[k]),*(r[k]));
          (u[k])->psinv(*(r[k]));
        }
       (u[k])->interp(*(u[(k) -(1)]));
       (r[k])->resid(*(u[k]),v);
       (u[k])->psinv(*(r[k]));
       return ;
}
void  s_elem:: psinv(s_elem &r){

       integer i3,i2,i1;
       position pos;
       static double c[4] = { ( (-(3.0))) / (8.0),((+(1.0))) / (32.0),( (-(1.0))) / (64.0),0.0 };
       for (i1 = start[0] ; (i1)<=(stop[0]) ; (i1)++)
       {
          for (i2 = start[1] ; (i2)<=(stop[1]) ; (i2)++)
          {
             for (i3 = start[2],pos = pos_ind(i1,i2,i3) ; (i3)<=(stop[2]) ; (i3)++,(pos)++)
             {
                (*(this ))(pos) += r.locsum(pos,c);
              }
           }
        }
}
void  s_elem:: loc_psinv(Gr__s_elem &r){

       psinv(elf(r,index1,index2));
}
void  Gr__s_elem:: psinv(Gr__s_elem &r){

       pcxx_UserTimerStart(PSINV);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->loc_psinv(r);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(PSINV);
       spread_and_comm3();
}
void  s_elem:: resid(s_elem &u, s_elem &v){

       integer i3,i2,i1;
       position pos;
       static double a[4] = { ( (-(8.0))) / (3.0),0.0,(1.0) / (6.0),(1.0) / (12.0) };
       for (i1 = start[0] ; (i1)<=(stop[0]) ; (i1)++)
       {
          for (i2 = start[1] ; (i2)<=(stop[1]) ; (i2)++)
          {
             for (i3 = start[2],pos = pos_ind(i1,i2,i3) ; (i3)<=(stop[2]) ; (i3)++,(pos)++)
             {
                (*(this ))(pos) = ((v)(pos)) -(u.locsum(pos,a));
              }
           }
        }
}
void  s_elem:: loc_resid(Gr__s_elem &u, Gr__s_elem &v){

       resid(elf(u,index1,index2),elf(v,index1,index2));
}
void  Gr__s_elem:: resid(Gr__s_elem &u, Gr__s_elem &v){

       pcxx_UserTimerStart(RESID);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->loc_resid(u,v);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(RESID);
       spread_and_comm3();
}
void  s_elem:: rprj3(s_elem &r){

       integer j3,j2,j1;
       position pos;
       static double prj[4] = { 0.5,0.25,0.125,0.0625 };
       for (j1 = start[0] ; (j1)<=(stop[0]) ; (j1)++)
       {
          for (j2 = start[1] ; (j2)<=(stop[1]) ; (j2)++)
          {
             for (j3 = start[2],pos = pos_ind(j1,j2,j3) ; (j3)<=(stop[2]) ; (j3)++,(pos)++)
             {
                (*(this ))(pos) = r.locsum((2) * (j1),(2) * (j2),(2) * (j3),prj);
              }
           }
        }
}
void  s_elem:: loc_rprj3(Gr__s_elem &r){

       rprj3(elf(r,index1,index2));
}
void  Gr__s_elem:: rprj3(Gr__s_elem &r){

       pcxx_UserTimerStart(PROJ);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->loc_rprj3(r);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(PROJ);
       spread_and_comm3();
}
void  s_elem:: interp(s_elem &z){

       integer mm[2][3];
       integer j,k,i3,i2,i1;
       for (k = 0 ; (k) < (3) ; (k)++)
       {
          mm[0][k] = ((start[k]) + (1)) / (2);
          mm[1][k] = ((stop[k]) + (1)) / (2);
        }
       for (i3 = mm[0][2] ; (i3)<=(mm[1][2]) ; (i3)++)
       {
          for (i2 = mm[0][1] ; (i2)<=(mm[1][1]) ; (i2)++)
          {
             for (i1 = mm[0][0] ; (i1)<=(mm[1][0]) ; (i1)++)
             {
                (*(this ))((2) * (i1),(2) * (i2),(2) * (i3)) += (z)(i1,i2,i3);
                (*(this ))(((2) * (i1)) -(1),(2) * (i2),(2) * (i3)) += (0.5) * (((z)((i1) -(1),i2,i3)) + ((z)(i1,i2,i3)));
                (*(this ))((2) * (i1),((2) * (i2)) -(1),(2) * (i3)) += (0.5) * (((z)(i1,(i2) -(1),i3)) + ((z)(i1,i2,i3)));
                (*(this ))(((2) * (i1)) -(1),((2) * (i2)) -(1),(2) * (i3)) += (0.25) * (((((z)((i1) -(1),(i2) -(1),i3)) + ((z)((i1) -(1),i2,i3))) + ((z)(i1,(i2) -(1),i3))) + ((z)(i1,i2,i3)));
                (*(this ))((2) * (i1),(2) * (i2),((2) * (i3)) -(1)) += (0.5) * (((z)(i1,i2,(i3) -(1))) + ((z)(i1,i2,i3)));
                (*(this ))(((2) * (i1)) -(1),(2) * (i2),((2) * (i3)) -(1)) += (0.25) * (((((z)((i1) -(1),i2,(i3) -(1))) + ((z)(i1,i2,(i3) -(1)))) + ((z)((i1) -(1),i2,i3))) + ((z)(i1,i2,i3)));
                (*(this ))((2) * (i1),((2) * (i2)) -(1),((2) * (i3)) -(1)) += (0.25) * (((((z)(i1,(i2) -(1),(i3) -(1))) + ((z)(i1,i2,(i3) -(1)))) + ((z)(i1,(i2) -(1),i3))) + ((z)(i1,i2,i3)));
                (*(this ))(((2) * (i1)) -(1),((2) * (i2)) -(1),((2) * (i3)) -(1)) += (0.125) * (((((((((z)((i1) -(1),(i2) -(1),(i3) -(1))) + ((z)((i1) -(1),i2,(i3) -(1)))) + ((z)(i1,(i2) -(1),(i3) -(1)))) + ((z)(i1,i2,(i3) -(1)))) + ((z)((i1) -(1),(i2) -(1),i3))) + ((z)((i1) -(1),i2,i3))) + ((z)(i1,(i2) -(1),i3))) + ((z)(i1,i2,i3)));
              }
           }
        }
}
void  s_elem:: loc_interp(Gr__s_elem &z){

       interp(elf(z,index1,index2));
}
void  Gr__s_elem:: interp(Gr__s_elem &z){

       pcxx_UserTimerStart(INTERP);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->loc_interp(z);
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(INTERP);
       spread_and_comm3();
}
void  s_elem:: zero3(){

       integer i1,i2,i3;
       position pos;
       for (i1 = (start[0]) -( !(has_neighbor[0][0])) ; (i1)<=((stop[0]) + ( !(has_neighbor[1][0]))) ; (i1)++)
       {
          for (i2 = (start[1]) -( !(has_neighbor[0][1])) ; (i2)<=((stop[1]) + ( !(has_neighbor[1][1]))) ; (i2)++)
          {
             for (i3 = (start[2]) -( !(has_neighbor[0][2])),pos = pos_ind(i1,i2,i3) ; (i3)<=((stop[2]) + ( !(has_neighbor[1][2]))) ; (i3)++,(pos)++)
             {
                (*(this ))(pos) = 0.0;
              }
           }
        }
}
void  s_elem:: loc_norm2u3(){

       double a;
       int i3,i2,i1;
       position pos;
       rnmu_tmp = rnm2_tmp = 0.0;
       for (i1 = start[0] ; (i1)<=(stop[0]) ; (i1)++)
       {
          for (i2 = start[1] ; (i2)<=(stop[1]) ; (i2)++)
          {
             for (i3 = start[2],pos = pos_ind(i1,i2,i3) ; (i3)<=(stop[2]) ; (i3)++,(pos)++)
             {
                a = fabs((*(this ))(pos));
                rnm2_tmp += (a) * (a);
                if ((a) >  (rnmu_tmp)) 
                {
                   rnmu_tmp = a;
                 }
               }
           }
        }
}
void  s_elem:: ResetNorm2u3(){

       loc_norm2u3();
}
void  s_elem:: normalize_norm(){

       rnm2_tmp = sqrt((rnm2_tmp) / ((((((pGr) ThisCollection)->n[0]) -(2)) * ((((pGr) ThisCollection)->n[1]) -(2))) * ((((pGr) ThisCollection)->n[2]) -(2))));
}
void  Gr__s_elem:: norm2u3(double &rnm2, double &rnmu){

       double total_u,total_2;
       int steps = 1;
       int locali;
       pcxx_UserTimerStart(NORM);
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->ResetNorm2u3();
        }
       _pcxx_Barrier();
       for ( ; (steps) < ((dim1size) * (dim2size)) ; steps *= 2)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->processor_norm2u3(this ,steps);
           }
          _pcxx_Barrier();
        }
       ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->normalize_norm();
        }
       _pcxx_Barrier();
       for (steps = ((dim1size) * (dim2size)) / (2) ; (steps)>=(1) ; steps = (steps) / (2))
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->LocalBroadcast(this ,steps);
           }
          _pcxx_Barrier();
        }
       locali = GetFirstLocalElementIndex(this );
       if ((locali)>=(0)) 
       {
          rnmu = ((*(this ))(locali))->rnmu_tmp;
          rnm2 = ((*(this ))(locali))->rnm2_tmp;
        }
        else{
          rnmu = *((double *) (this )->Get_ElementPart(0,(((int) &(dummy.rnmu_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnmu_tmp) / (sizeof (int) )));
          rnm2 = *((double *) (this )->Get_ElementPart(0,(((int) &(dummy.rnm2_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnm2_tmp) / (sizeof (int) )));
        }
       _pcxx_Barrier();
       pcxx_UserTimerStop(NORM);
}
void  s_elem:: LocalBroadcast(Gr__s_elem *array, int step){

       int ind;
       ind = (ThisCollection)->GlobalIndex(index1,index2);
       if (((ind) && (((ind)% (step)) == (0))) && ( !(((ind)% ((2) * (step))) == (0)))) 
       {
          rnm2_tmp = *((double *) (array)->Get_ElementPart((ind) -(step),(((int) &(dummy.rnm2_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnm2_tmp) / (sizeof (int) )));
          rnmu_tmp = *((double *) (array)->Get_ElementPart((ind) -(step),(((int) &(dummy.rnmu_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnmu_tmp) / (sizeof (int) )));
        }
 }
void  s_elem:: processor_norm2u3(Gr__s_elem *array, int step){

       if (((((ThisCollection)->GlobalIndex(index1,index2))% ((2) * (step))) == (0)) && (((ThisCollection)->GlobalIndex((index1) + (step),index2)) < (((dimsize[0]) * (dimsize[1])) * (dimsize[2])))) 
       {
          double  *tmp;
          tmp = (double *) (array)->Get_ElementPart((index1) + (step),index2,(((int) &(dummy.rnm2_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnm2_tmp) / (sizeof (int) ));
          rnm2_tmp += *(tmp);
          tmp = (double *) (array)->Get_ElementPart((index1) + (step),index2,(((int) &(dummy.rnmu_tmp)) -((int) &(dummy))) / (sizeof (int) ),(sizeof dummy.rnmu_tmp) / (sizeof (int) ));
          if ((*(tmp)) >  (rnmu_tmp)) 
          {
             rnmu_tmp = *(tmp);
           }
         }
 }
struct sorted_item {
       double t;
       int j1,j2,j3;
        sorted_item:: sorted_item(){
       
       }
        sorted_item:: sorted_item(double _t, int _j1, int _j2, int _j3){
       
          t = _t;
          j1 = _j1;
          j2 = _j2;
          j3 = _j3;
       }
} ;
void  bubble(sorted_item ten[], int m, double dir);
double randlc(double &X, double A);
void  vranlc(int n, double &x, double a, double y[]);
void  Gr__s_elem:: zran3(){

       integer i1,i2,i3;
       double a;
       const int m = 10;
       double x = 314159265.0;
       sorted_item ten[2][m];
       sorted_item  *tp = ten[1],*tm = ten[0];
       double  *s;
       int i;
       a = pow(5.0,13.0);
       for (i = 0 ; (i) < (m) ; (i)++)
       {
          tp[i].t = 0;
          tm[i].t = 1;
        }
       s = new double [(n[0]) -(1)] ;
       for (i3 = 1 ; (i3) < ((n[2]) -(1)) ; (i3)++)
       {
          for (i2 = 1 ; (i2) < ((n[1]) -(1)) ; (i2)++)
          {
             vranlc((n[0]) -(2),x,a,(s) + (1));
             for (i1 = 1 ; (i1) < ((n[0]) -(1)) ; (i1)++)
             {
                if ((s[i1]) >  (tp[0].t)) 
                {
                   tp[0] = sorted_item(s[i1],i1,i2,i3);
                   bubble(tp,m,(+(1.0)));
                 }
                 if ((s[i1]) < (tm[0].t)) 
                {
                   tm[0] = sorted_item(s[i1],i1,i2,i3);
                   bubble(tm,m, (-(1.0)));
                 }
               }
           }
        }
       char format7[] = " (%3d,%3d,%3d)";
       if ((pcxx_NodeNumber()) == (0)) 
       {
          printf(" negative charges at\n");
          for (i = 0 ; (i) < (m) ; (i)++)
          {
             printf(format7,tm[i].j1,tm[i].j2,tm[i].j3);
             if (((i)% (5)) == (4)) 
             {
                printf("\n");
              }
            }
          printf(" positive charges at\n");
          for (i = 0 ; (i) < (m) ; (i)++)
          {
             printf(format7,tp[i].j1,tp[i].j2,tp[i].j3);
             if (((i)% (5)) == (4)) 
             {
                printf("\n");
              }
            }
        }
        ResetLocal(this );
       for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
       {
          pcxx_Poll();
          ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->zero3();
        }
       _pcxx_Barrier();
       for (i = 0 ; (i) < (m) ; (i)++)
       {
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->set_value(tm[i].j1,tm[i].j2,tm[i].j3, (-(1.0)));
           }
          _pcxx_Barrier();
          ResetLocal(this );
          for ((GlobalVars[pcxx_NodeNumber()].VarpC_0) = FirstLocal() ; ((GlobalVars[pcxx_NodeNumber()].VarpC_0))>=(0) ; (GlobalVars[pcxx_NodeNumber()].VarpC_0) = Local((GlobalVars[pcxx_NodeNumber()].VarpC_0)))
          {
             pcxx_Poll();
             ((*(this ))((GlobalVars[pcxx_NodeNumber()].VarpC_0)))->set_value(tp[i].j1,tp[i].j2,tp[i].j3,(+(1.0)));
           }
          _pcxx_Barrier();
        }
       spread_and_comm3();
       delete  s;
}
void   bubble(sorted_item ten[], int m, double dir){

       int i;
       for (i = 0 ; ((i) < ((m) -(1))) && (((dir) * (ten[i].t)) >  ((dir) * (ten[(i) + (1)].t))) ; (i)++)
       {
          sorted_item s_tmp = ten[(i) + (1)];
          ten[(i) + (1)] = ten[i];
          ten[i] = s_tmp;
        }
}
double  randlc(double &X, double A){

       double A1,A2,X1,X2,T1,T3,Y;
       double R23,R46,T23,T46;
       R23 = ldexp(1.0, (-(23)));
       R46 = (R23) * (R23);
       T23 = ldexp(1.0,23);
       T46 = (T23) * (T23);
       {
          A1 = floor((A) * (R23));
          A2 = (A) -((A1) * (T23));
        }
       {
          X1 = floor((X) * (R23));
          X2 = (X) -((X1) * (T23));
        }
       T1 = ((A1) * (X2)) + ((A2) * (X1));
       Y = (T1) -((floor((T1) * (R23))) * (T23));
       T3 = ((T23) * (Y)) + ((A2) * (X2));
       X = (T3) -((floor((T3) * (R46))) * (T46));
       return (R46) * (X);
}
void   vranlc(int n, double &x, double a, double y[]){

       double R23,R46,T23,T46;
       R23 = ldexp(1.0, (-(23)));
       R46 = (R23) * (R23);
       T23 = ldexp(1.0,23);
       T46 = (T23) * (T23);
       const int nv = 64;
       double xv[nv],t1,t2,t3,an,a1,a2,x1,x2;
       integer n1,j;
       int i;
       t1 = x;
       n1 = ((n) >  (nv))?nv:n;
       for (i = 0 ; (i) < (n1) ; (i)++)
       {
          xv[i] = (T46) * (randlc(t1,a));
        }
       if ((n) >  (nv)) 
       {
          t1 = a;
          t2 = (R46) * (a);
          for (i = 0 ; (i) < ((nv) -(1)) ; (i)++)
          {
             t2 = randlc(t1,a);
           }
          an = (T46) * (t2);
          {
             a1 = floor((an) * (R23));
             a2 = (an) -((a1) * (T23));
           }
        }
        for (j = 0 ; (j) < (n) ; j += nv)
       {
          n1 = ((nv) >  ((n) -(j)))?(n) -(j):nv;
          for (i = 0 ; (i) < (n1) ; (i)++)
          {
             y[(i) + (j)] = (R46) * (xv[i]);
           }
          if (((j) + (n1)) == (n)) 
          {
             break;
           }
           for (i = 0 ; (i) < (nv) ; (i)++)
          {
             x1 = floor((xv[i]) * (R23));
             x2 = (xv[i]) -((x1) * (T23));
             t1 = ((a1) * (x2)) + ((a2) * (x1));
             t3 = ((T23) * ((t1) -((floor((t1) * (R23))) * (T23)))) + ((a2) * (x2));
             xv[i] = (t3) -((floor((t3) * (R46))) * (T46));
           }
        }
       x = xv[(n1) -(1)];
       return ;
}

#include "align_function.h"

void DuplicateGlobalVars(int num_threads)
{
  GlobalVars = (GVars *) malloc ( sizeof(GVars) * num_threads );
}
