//  ----------------------------------
//  Darryl Brown
//  University of Oregon pC++/Sage++
//
//  breakpoint.C  -  module for inspecting a pC++ program
//       at breakpoints.
//
//  
//  ----------------------------------

#include <stdio.h>
#include <stdlib.h>

#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif
 
#include "baseClasses.h"

//--------------------------------------------------//  

// This points to the queue which names of collection variables are
//  placed just before they are created.
brk_linkedList *brk_BPcollDeclQueue = new brk_linkedList();

// This points to the tables (list) of collection instances and a record
// of information about them.
brk_linkedList *brk_BPcollInstanceTable = new brk_linkedList();

int brk_BREAKPOINT_TOGGLE_VAR=1;

FILE *brk_openOutFile() {
  
  return stdout;

}


FILE *brk_openInFile() {
  
  return stdin;


}








