/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


# include <stdio.h>

void Message (st, flag)
char *st;
int flag;
{
  printf ("Message: %s\n", st);
}

Processor_Main ()
{
  int *x;

  SMRTSAllocElemSpace (pcxx_NodeNumber(), sizeof(int));
  pcxx_Barrier();
  printf ("[1] hello from %2d of %d\n", pcxx_NodeNumber(), pcxx_TotalNodes());
  x = (int *) SMRTSGetElemSpacePtr (pcxx_NodeNumber());
  *x = 99 + pcxx_NodeNumber();
  pcxx_Barrier();
  x = (int *) SMRTSGetElemSpacePtr (1);
  printf ("[2] hello from %2d of %d (%d)\n", pcxx_NodeNumber(), pcxx_TotalNodes(), *x);
  pcxx_Barrier();
  x = (int *) SMRTSGetElemSpacePtr (pcxx_NodeNumber());
  SMRTSDealloc (x);
}

New_Main (id)
void *id;
{
  SMRTSNewProc((int) id);
  Processor_Main();
}

main (argc, argv)
int argc;
char **argv;
{
  InitParam (&argc, argv);
  SMRTSSetup ();
  SMRTSFork (argc, argv);
}
