/* 
//  ----------------------------------
//  Darryl Brown
//  University of Oregon pC++/Sage++
//
//  brkExecInc.h  -  module for inspecting a pC++ program
//       at breakpoints that must be compiled with the 
//       runtime system (file which implements pcxx_barrier());
//
//  Note that this file needs to be only straight c code.
//  ----------------------------------
*/

#ifdef BRKPNT_ON

/*  breakpointing IS turned on */

#define brk_TOGGLE_BREAKPOINT (brk_BREAKPOINT_TOGGLE_VAR *= -1)

#ifdef __cplusplus
extern "C" {
#endif

void brk_BREAKPOINT_EXECUTIVE();

#ifdef __cplusplus
}
#endif


#else 

/*  breakpointing IS NOT turned on */
#define brk_BREAKPOINT_EXECUTIVE()

#endif
